unit samplef;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, GestureCtrls, StdCtrls, GestureMgr, XPMan;

type
  TSampleForm = class(TForm)
    GroupBox1: TGroupBox;
    GestureLV: TGestureListView;
    GestureBox: TGroupBox;
    GroupBox3: TGroupBox;
    GestureRecorder: TGestureRecorder;
    GroupBox4: TGroupBox;
    GestureEd: TEdit;
    AddButton: TButton;
    GMng: TGestureManager;
    StsBar: TStatusBar;
    XPManifest1: TXPManifest;
    GroupBox2: TGroupBox;
    GesturePrv: TGesturePreview;
    procedure GestureRecorderGestureRecorded(Sender: TObject;
      RecordedGesture: TGestureCollectionItem);
    procedure GestureEdKeyPress(Sender: TObject; var Key: Char);
    procedure GestureEdChange(Sender: TObject);
    procedure AddButtonClick(Sender: TObject);
    procedure GestureLVKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure GestureBoxGesture(Sender: TObject;
      const EventInfo: TGestureEventInfo; var Handled: Boolean);
  private
    { Private 錾 }
    procedure AddGestureFromText;
    function  CheckGesture(AGesture:TCustomGestureCollectionItem; ANameCheck:boolean):boolean;
  public
    { Public 錾 }
  end;

var
  SampleForm: TSampleForm;

implementation

{$R *.dfm}

uses
  Gestures, simplegestures;

//
// lGestureA͓Gestureꍇ͋UԂ
//
function TSampleForm.CheckGesture(AGesture:TCustomGestureCollectionItem; ANameCheck:boolean):boolean;
var
  work : TCustomGestureCollectionItem;
begin
  result:=false;
  // Gesture`FbN
  for work in GMng.RecordedGestures do
    if 0.0<TGestureEngine.Recognizer.Match(work.Points,AGesture.Points,
                                           work.Options,work.GestureID,
                                           work.Deviation,work.ErrorMargin) then begin
      ShowMessage(AGesture.Name+'  '+Work.Name+' Ɠgestureł');
      Exit;
    end;
  // `FbN
  if ANameCheck and (GMng.FindCustomGesture(AGesture.Name)<>nil) then begin
    ShowMessage(AGesture.Name+' ƂO͊ɓo^ς݂ł');
    Exit;
  end;
  // all ok
  result:=true;
end;

//
// GestureRecorderɂGesture̓o^
//
procedure TSampleForm.GestureRecorderGestureRecorded(Sender: TObject;
  RecordedGesture: TGestureCollectionItem);
begin
  RecordedGesture.Name:='REC_'+IntToStr(GMng.RecordedGestureCount);
  if CheckGesture(RecordedGesture,false) then begin
    RecordedGesture.GestureID:=GMng.AddRecordedGesture(RecordedGesture);
    GMng.SelectGesture(GestureBox,RecordedGesture.GestureID)
  end;
end;

//
// ɂGesture̓o^
//
procedure TSampleForm.GestureEdChange(Sender: TObject);
begin
  AddButton.Enabled:=GestureEd.Text<>'';
end;

procedure TSampleForm.GestureEdKeyPress(Sender: TObject; var Key: Char);
begin
  case Key of
    'u','U' : Key:='U';
    'd','D' : Key:='D';
    'r','R' : Key:='R';
    'l','L' : Key:='L';
    #8      : Key:=#8;
    #13     : AddGestureFromText;
    else
      Key:=#0;
  end;
end;

procedure TSampleForm.AddButtonClick(Sender: TObject);
begin
  AddGestureFromText;
end;

procedure TSampleForm.AddGestureFromText;
const
  Delta = 50;
var
  ACustomGesture : TGestureCollectionItem;
  function MakeGesture:TGestureCollectionItem;
  var
    i : integer;
    points : TGesturePointArray;
  begin
    result:=TGestureCollectionItem.Create(nil);
    SetLength(points,Length(GestureEd.Text)+1);
    points[0].X:=0; points[0].Y:=0;
    for i := 1 to Length(GestureEd.Text) do begin
      case GestureEd.Text[i] of
        'U': with points[i] do begin x:=points[i-1].X;       y:=points[i-1].Y-delta; end;
        'D': with points[i] do begin x:=points[i-1].X;       y:=points[i-1].Y+delta; end;
        'L': with points[i] do begin x:=points[i-1].X-delta; y:=points[i-1].Y; end;
        'R': with points[i] do begin x:=points[i-1].X+delta; y:=points[i-1].Y; end;
      end;
    end;
    result.Points:=TGestureEngine.Recognizer.NormalizePoints(points);
    result.Name:='CST_'+GestureEd.Text;
    result.Options:=[goUniDirectional];
    result.Deviation:= 30;
    result.ErrorMargin:= 20;
  end;
begin
  if GestureEd.Text='' then Exit;
  //
  ACustomGesture:=MakeGesture;
  try
    if CheckGesture(ACustomGesture,true) then begin
      ACustomGesture.GestureID:=GMng.AddRecordedGesture(ACustomGesture);
      GMng.SelectGesture(GestureBox,ACustomGesture.GestureID);
      GestureEd.Text:='';
    end;
  finally
    ACustomGesture.Free;
  end;
end;

//
// o^Gesture̍폜
//
procedure TSampleForm.GestureLVKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  GestureName : string;
  Gesture : TCustomGestureCollectionItem;
begin
  if (Key=VK_DELETE) and (GestureLv.ItemIndex<>-1) then begin
    GestureName:=GestureLV.Items[GestureLv.ItemIndex].Caption;
    Gesture:=GMng.FindGesture(GestureBox,GestureName);
    if Gesture<>nil then begin
      // ̂ƂgestureuSɁv폜@s
      //GMng.UnselectGesture(GestureBox,Gesture.GestureID);
      //GMng.RemoveRecordedGesture(Gesture.GestureID);
    end;
  end;
end;

//
// Gesture̔
//
procedure TSampleForm.GestureBoxGesture(Sender: TObject;
  const EventInfo: TGestureEventInfo; var Handled: Boolean);
const
  ButtonMsg : array[gbNone..gbX2] of string = ('None','Left','Right','Middle','X1','X2');
var
  Gesture: TCustomGestureCollectionItem;
  GE : TSimpleMouseGestureEngine;
begin
  Gesture:=GMng.FindCustomGesture(EventInfo.GestureID);
  if GestureBox.Touch.GestureEngine is TSimpleMouseGestureEngine then begin
    GE:=TSimpleMouseGestureEngine(GestureBox.Touch.GestureEngine);
    if Gesture=nil then
      StsBar.SimpleText:='Unkown '+ButtonMsg[GE.LastGestureButton]+' Button Gesture'
    else
      StsBar.SimpleText:=ButtonMsg[GE.LastGestureButton]+' Button Gesture : '+Gesture.Name;
  end else begin
    if Gesture=nil then
      StsBar.SimpleText:='Unkown Gesture'
    else
      StsBar.SimpleText:='Gesture : '+Gesture.Name;
  end;
end;


end.
