unit simplegestures;

//////////////////////////////////////////////////////////////////////////
//
// SimpleGestureRecognizer & SimpleMouseGestureEngine
//
// Copyright (C) 2009 Ayakawa,Marinosuke & MarleySoft
//
// http://homepage1.nifty.com/Ayakawa/
//
// gpEǁE]ځEzz
//@ ̃jbgɂāAgpE]ځEzz͂RɂȂĂB
// @A]ځEzzƂ̓A[JCu̍\͕ςȂłB
//   OE̘A͂܂B
//   ǂ̂ARɎgpEzzE]ڂĂB
//
// 񑩂
// @̃jbgA͉ρEǂꂽjbg̎gpɂAȂ炩
//   ̔QĂҁ@fTisہ@j́A؂̐ӔCE`
//   𕉂܂BgpɂȂ̐ӔČɁǍʂ𕉂Ă
//   Bꂪ[Ȃ̂ł΁ApfOĂB
//
// g : projectt@C Application.Initialize; ̑OɂQsǉ
//
//            TGestureEngine.DefaultEngineClass:=TMouseGestureEngine;
//            TGestureEngine.DefaultRecognizerClass:=TSimpleGestureRecognizer;
//            Application.Initialize;
//
//          defaultTPlatformGestureEngineƉHꂽPointsn
//          邽߁ATSimpleGestureRecognizer딻肵܂B
//
//          originalƂ͈قȂAPɏ㉺EɃ}EXǂ
//          𔻒肵Ă܂B΂߂͑ΉĂ܂B
//
//          2010tTMouseGestureEngine͍{^݂̂̑ΉłBȊO
//          ̃{^ɂGesturegpꍇTSimpleMouseGestureEngine
//          gpĂB
//
//            TGestureEngine.DefaultEngineClass:=TSimpleMouseGestureEngine;
//
//          TSimpleMouseGestureEngine̓ftHgōEE{^T|[g
//          Ă܂BESET{^̃WFX`[gpꍇ
//
//            TSimpleMouseGestureEngine.SupportedButtons:=
//                                        [gbLeft,gbRight,gbMiddle,gbX1,gbX2];
//
//          ̂悤ɋLqĂB
//
// ӓ_ : TSimpleGestureRecognizerstanard gestureɂ́wSΉĂ܂x
//
// rev. 0
// auth 
// date 2009/08/31
// memo FireGesture LikeɁAPUDLR
//
// rev. 1
// auth 
// date 2009/09/01
// memo TSimpleMouseGestureEngine쐬
//
//////////////////////////////////////////////////////////////////////////

interface

uses
  windows,Types,messages,sysutils,controls,gestures;

type
  //
  // GestureRecognizer - simpleɁ̂Ŝ݈
  //
  TSimpleGestureRecognizer = class(TCustomGestureRecognizer)
  protected
    function PointsToGestureStr(const Points: array of TPoint):string; virtual;
    function GestureStrToPoints(const AGestureStr:string):TGesturePointArray; virtual;
  public
    function Match(const Points, GesturePoints: array of TPoint;
      const Options: TGestureOptions; GestureID: TGestureID;
      Deviation, ErrorMargin: Integer): Single; override;
    function NormalizePoints(const Points: array of TPoint): TGesturePointArray; override;
    function ScalePoints(const Points, GesturePoints: array of TPoint;
      MinScale: Integer; Scaling: Boolean = False): TGesturePointArray; override;
  end;

  TSimpleGestureRecognizerClass = class of TSimpleGestureRecognizer;

  //
  // GestureEngine - Left,Right,Middle,X1,X2MouseGestureEngine
  //
  TGestureButton = (gbNone,gbLeft,gbRight,gbMiddle,gbX1,gbX2);
  TGestureButtons = set of TGestureButton;

  TSimpleMouseGestureEngine = class(TGestureEngine)
  strict private
    FActive: Boolean;
    FLastGestureButton,
    FGestureButton : TGestureButton;
    class var FSupportedButtons : TGestureButtons;
  protected
    function  GetActive: Boolean; override;
    function  GetFlags: TCustomGestureEngine.TGestureEngineFlags; override;
    procedure SetActive(const Value: Boolean); override;
    class procedure SetSupportedButtons(AButtons:TGestureButtons); static;
  public
    destructor Destroy; override;
    procedure  Notification(const Message: TMessage); override;
    class function Supported: Boolean; override;
    class property SupportedButtons: TGestureButtons read FSupportedButtons write SetSupportedButtons;
    property   LastGestureButton : TGestureButton read FLastGestureButton;
  end;

implementation

const
  DIR_N = 'N'; // Ȃ - 
  DIR_U = 'U';
  DIR_D = 'D';
  DIR_L = 'L';
  DIR_R = 'R';

  GESTURE_NO_MATCHED = 0.0;
  GESTURE_MATCHED    = 100.0;

  MinDistance = 10;

procedure DebugStr(const header:string; const Points: array of TPoint);
var
  i : integer;
  r : string;
begin
  r:='';
  for i := 0 to High(Points) do
    if r='' then
      r:='('+IntToStr(Points[i].X)+','+IntToStr(Points[i].Y)+')'
    else
      r:=r+'-('+IntToStr(Points[i].X)+','+IntToStr(Points[i].Y)+')';
  OutputDebugString(PWideChar(header+':'+r));
end;

function TSimpleGestureRecognizer.PointsToGestureStr(const Points: array of TPoint):string;
  function absi(a:integer):integer;
  begin
    if a<0 then
      result:=-a
    else
      result:=a;
  end;
var
  i,max,dx,dy : integer;
  LastPt : TPoint;
  LastDir,Dir : Char;
begin
  result:='';
  max:=High(Points);
  if max<1 then exit; // |CgPȉȂ
  // P
  LastPt:=Points[0];
  LastDir:=DIR_N; Dir:=DIR_N;
  for i := 1 to max do begin
    // x,y̕ϓ擾
    dx:=points[i].X-LastPt.X; dy:=points[i].Y-LastPt.Y;
    // x,y̕ϓꂼ10ptȂ疳
    if (absi(dx)<MinDistance) and (absi(dy)<MinDistance) then continue;
    // ǂɃ}EXړ`FbN
    if absi(dx)>absi(dy) then begin
      if dx<0 then Dir:=DIR_L else Dir:=DIR_R;
    end else begin
      if dy<0 then Dir:=DIR_U else Dir:=DIR_D;
    end;
    //
    LastPt:=Points[i];
    // O`FbNƕύXĂ
    if LastDir<>Dir then begin
      case Dir of
        DIR_U : result:=result+DIR_U;
        DIR_D : result:=result+DIR_D;
        DIR_R : result:=result+DIR_R;
        DIR_L : result:=result+DIR_L;
      end;
      LastDir:=Dir; Dir:=DIR_N;
    end;
  end;
  if (Dir<>Dir_N) and (Dir<>LastDir) then result:=result+Dir;
end;

function TSimpleGestureRecognizer.GestureStrToPoints(const AGestureStr:string):TGesturePointArray;
var
  NormalizedStr : string;
  i,max : integer;
  minx,miny : longint;
  PrevChar : Char;
begin
  NormalizedStr:='';
  // ]vȕ͍Ă
  PrevChar:=DIR_N;
  for I := 1 to Length(AGestureStr) do
    if CharInSet(AGestureStr[i],[DIR_U,DIR_D,DIR_L,DIR_R]) and (AGestureStr[i]<>PrevChar) then begin
      NormalizedStr:=NormalizedStr+AGestureStr[i];
      PrevChar:=AGestureStr[i];
    end;
  // points𐶐
  max:=Length(NormalizedStr);
  SetLength(result,max+1);
  result[0].x:=0; result[0].Y:=0;
  if max<1 then exit;
  for I := 1 to max do begin
    case NormalizedStr[i] of
      DIR_U : begin result[i].X:=result[i-1].X; result[i].Y:=result[i-1].Y-MinDistance; end;
      DIR_D : begin result[i].X:=result[i-1].X; result[i].Y:=result[i-1].Y+MinDistance; end;
      DIR_L : begin result[i].X:=result[i-1].X-MinDistance; result[i].Y:=result[i-1].Y; end;
      DIR_R : begin result[i].X:=result[i-1].X+MinDistance; result[i].Y:=result[i-1].Y; end;
    end;
  end;
  // (0,0)`ɂĂ
  minx:=0; miny:=0;
  for i := 0 to max do begin
    if minx>result[i].x then minx:=result[i].X;
    if miny>result[i].y then miny:=result[i].y;
  end;
  for i := 0 to max do begin
    if minx<0 then Dec(result[i].X,minx);
    if miny<0 then Dec(result[i].Y,miny);
  end;
end;

function TSimpleGestureRecognizer.Match(const Points, GesturePoints: array of TPoint;
                                        const Options: TGestureOptions; GestureID: TGestureID;
                                        Deviation, ErrorMargin: Integer): Single;
var
  PointsStr,GesturePointsStr : string;
begin
  result:=GESTURE_NO_MATCHED;
  PointsStr:=PointsToGestureStr(Points);
  GesturePointsStr:=PointsToGestureStr(GesturePoints);
  //OutputDebugString(PWideChar('"'+PointsStr+'" / "'+GesturePointsStr+'"'));
  if (PointsStr='') or (GesturePointsStr='') then Exit;
  if PointsStr=GesturePointsStr then result:=GESTURE_MATCHED;
end;

function TSimpleGestureRecognizer.NormalizePoints(const Points: array of TPoint): TGesturePointArray;
begin
  //DebugStr('NormO',Points);
  result:=GestureStrToPoints(PointsToGestureStr(Points));
  //DebugStr('Norm',result);
end;

function TSimpleGestureRecognizer.ScalePoints(const Points, GesturePoints: array of TPoint;
                                              MinScale: Integer;
                                              Scaling: Boolean): TGesturePointArray;
begin
  // only normalize
  result:=NormalizePoints(Points);
end;

const
  CustomGestureTypes: TGestureTypes = [gtRecorded, gtRegistered];

destructor TSimpleMouseGestureEngine.Destroy;
begin
  Active := False;
  FGestureButton:=gbNone;
  FLastGestureButton:=gbNone;
  inherited;
end;

function TSimpleMouseGestureEngine.GetActive: Boolean;
begin
  Result := FActive;
end;

function TSimpleMouseGestureEngine.GetFlags: TCustomGestureEngine.TGestureEngineFlags;
begin
  Result := [efMouseEvents];
end;

procedure TSimpleMouseGestureEngine.Notification(const Message: TMessage);
const
  XBUTTON1 = 1;
  XBUTTON2 = 2;
var
  LPoint: TPoint;
  LGestureList: TGestureList;
  LEventInfo: TGestureEventInfo;
  procedure StartGesture(AButton:TGestureButton);
  begin
    // gestureJnĂȂΏI
    if FGestureButton<>gbNONE then exit;

    // Ώۂ̃{^łȂ̂łΏI
    if NOT (AButton in SupportedButtons) then Exit;

    // Find control that gesture belongs to
    LPoint := Point(TWMMouse(Message).XPos, TWMMouse(Message).YPos);
    TargetControl := Control.ControlAtPos(LPoint, False);
    if TargetControl = nil then
      TargetControl := Control
    else
      if not (csGestures in TargetControl.ControlStyle) then
        Exit;

    // Convert to screen coordinates for use in BroadcastGesture
    InitialPoint := Control.ClientToScreen(LPoint);

    // Add initial point to list of collected points
    ClearPoints;
    AddPoint(TWMMouse(Message).XPos, TWMMouse(Message).YPos);

    // Start timer
    StartTimer;

    //
    FGestureButton:=AButton;
  end;
  procedure EndGesture(AButton:TGestureButton);
  begin
    // gestureJñ{^ł͂Ȃꍇ͏I
    if FGestureButton<>AButton then exit;

    //
    if not TimerExpired and (PointCount > 0) then
    begin
      // Reset timer
      ResetTimer;

      // Add final point to list
      AddPoint(TWMMouse(Message).XPos, TWMMouse(Message).YPos);

      try
        LGestureList := TGestureList.Create;
        try
          // Retrieve list of gestures
          GetCompleteGestureList(TargetControl, LGestureList);

          // Request gesture recognition
          if TGestureEngine.IsGesture(Points, LGestureList, [gtStandard] + CustomGestureTypes, LEventInfo) then begin
            FLastGestureButton:=AButton;
            BroadcastGesture(TargetControl, LEventInfo);
          end;
        finally
          LGestureList.Free;
        end;
      finally
        FGestureButton:=gbNone;
      end;
    end;
  end;
begin
  if FActive then
    case Message.Msg of
      WM_MOUSEMOVE:
        if not TimerExpired then
          AddPoint(TWMMouse(Message).XPos, TWMMouse(Message).YPos)
        else
        begin
          ResetTimer;
          ClearPoints;
        end;
      WM_LBUTTONDOWN:
        StartGesture(gbLeft);
      WM_RBUTTONDOWN:
        StartGesture(gbRight);
      WM_MBUTTONDOWN:
        StartGesture(gbMiddle);
      WM_XBUTTONDOWN:
        if Message.WParamHi=XBUTTON1 then
          StartGesture(gbX1)
        else if Message.WParamHi=XBUTTON2 then
          StartGesture(gbX2);
      WM_LBUTTONUP:
        EndGesture(gbLeft);
      WM_RBUTTONUP:
        EndGesture(gbRight);
      WM_MBUTTONUP:
        EndGesture(gbMiddle);
      WM_XBUTTONUP:
        if Message.WParamHi=XBUTTON1 then
          EndGesture(gbX1)
        else if Message.WParamHi=XBUTTON2 then
          EndGesture(gbX2);
    end;
end;

procedure TSimpleMouseGestureEngine.SetActive(const Value: Boolean);
begin
  if Value <> FActive then
  begin
    FActive := Value;
    if not FActive and not TimerExpired then
    begin
      ResetTimer;
      ClearPoints;
    end;
  end;
end;

class function TSimpleMouseGestureEngine.Supported: Boolean;
begin
  Result := True;
end;

class procedure TSimpleMouseGestureEngine.SetSupportedButtons(AButtons:TGestureButtons);
begin
  FSupportedButtons:=AButtons;
  Exclude(FSupportedButtons,gbNone); // gbNone͌ăT|[gȂ
end;

initialization
  TSimpleMouseGestureEngine.SupportedButtons:=[gbLeft,gbRight];

end.
